'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var react = require('react');
var arePassiveEventsSupported = require('are-passive-events-supported');
var useLatest = require('use-latest');

function _interopDefault (e) { return e && e.__esModule ? e : { 'default': e }; }

var arePassiveEventsSupported__default = /*#__PURE__*/_interopDefault(arePassiveEventsSupported);
var useLatest__default = /*#__PURE__*/_interopDefault(useLatest);

var MOUSEDOWN = 'mousedown';
var TOUCHSTART = 'touchstart';
var events = [MOUSEDOWN, TOUCHSTART];

var getAddOptions = function getAddOptions(event) {
  if (event === TOUCHSTART && arePassiveEventsSupported__default['default']()) {
    return {
      passive: true
    };
  }
};

var currentDocument = document ;
function useOnClickOutside(ref, handler, _temp) {
  var _ref = _temp === void 0 ? {} : _temp,
      _ref$document = _ref.document,
      document = _ref$document === void 0 ? currentDocument : _ref$document;

  var handlerRef = useLatest__default['default'](handler);
  react.useEffect(function () {
    if (!handler) {
      return;
    }

    var listener = function listener(event) {
      if (!ref.current || !handlerRef.current || ref.current.contains(event.target)) {
        return;
      }

      handlerRef.current(event);
    };

    events.forEach(function (event) {
      document.addEventListener(event, listener, getAddOptions(event));
    });
    return function () {
      events.forEach(function (event) {
        document.removeEventListener(event, listener);
      });
    };
  }, [!handler]);
}

exports.default = useOnClickOutside;
